//+------------------------------------------------------------------+
//|                                                    variation.mq4 |
//|                                         Copyright  2010, LeMan. |
//|                                                 b-market@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, LeMan."
#property link      "b-market@mail.ru"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- input parameters
extern string TimeFrame    = "current time frame";
extern int       N=20;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
int    timeFrame;
string indicatorFileName;
bool   returnBars;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
  IndicatorDigits(Digits+2);
  IndicatorBuffers(2);
   if (N <= 0) N = 20;   
      SetIndexBuffer(0,ExtMapBuffer1); SetIndexDrawBegin(0, N*2); 
      SetIndexBuffer(1,ExtMapBuffer2);
      string short_name = "Variation (" + N + ")";
         IndicatorShortName(short_name);
         SetIndexLabel(0, short_name);     
         
      timeFrame         = stringToTimeFrame(TimeFrame);
      returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
      indicatorFileName = WindowExpertName();
   return(0);
}
int deinit(){ return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }
         
         //
         //
         //
         //
         //

         if (timeFrame!=Period()) 
         { 
             limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
             for (int i=int limit;i>=0; i--)
             {
                int y = iBarShift(NULL,timeFrame,Time[i]);
                  ExtMapBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"",N,0,y); 
             }
             return(0);
         }  
         
   //
   //
   //
   //
   //
            
   for (i = limit; i >= 0; i--) ExtMapBuffer2[i] = Close[i]-iMA(NULL,0,N,0,MODE_SMA,PRICE_CLOSE,i);
   for (i = limit; i >= 0; i--)
   {   
      double vr = iMAOnArray(ExtMapBuffer2,Bars,N,0,MODE_SMA,i);
      double mov = iMA(NULL,0,N,0,MODE_SMA,PRICE_CLOSE,i);
             ExtMapBuffer1[i] = Close[i] - (mov + vr);
   }    
   return(0);
  }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}